/*
 * Ubiquity REST API
 * Ubiquity provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Protocols #### Mainnet The following protocols are currently supported: * bitcoin * ethereum * polkadot * xrp * algorand * stellar * dogecoin * oasis * stacks * near  #### Testnet * bitcoin/testnet * ethereum/ropsten * dogecoin/testnet  #### Native Ubiquity provides native access to all Blockchain nodes it supports. To access native functionality, use the protocol without the v2 prefix * bitcoin/(mainnet | testnet) - [RPC Documentation](https://developer.bitcoin.org/reference/rpc/) * ethereum/(mainnet | ropsten) - [RPC Documentation](https://ethereum.org/en/developers/docs/apis/json-rpc/) * polkadot/mainnet - [Sidecar API Documentation](https://paritytech.github.io/substrate-api-sidecar/dist/) * polkadot/mainnet/http-rpc - [Polkadot RPC Documentation](https://polkadot.js.org/docs/substrate/rpc/) * algorand/mainnet - [Algod API Documentation](https://developer.algorand.org/docs/reference/rest-apis/algod/v1/) * stellar/mainnet - [Stellar Horizon API Documentation](https://developers.stellar.org/api) * dogecoin/(mainnet | testnet) - [Dogecoin API Documentaion](https://developer.bitcoin.org/reference/rpc/) * oasis/mainnet - [Oasis Rosetta Gateway Documentation](https://www.rosetta-api.org/docs/api_identifiers.html#network-identifier) * stacks/mainnet - [Stacks API Documentation](https://blockstack.github.io/stacks-blockchain-api/) * near/mainnet - [NEAR RPC Documentation](https://docs.near.org/docs/api/rpc)  A full URL example: https://ubiquity.api.blockdaemon.com/_**bitcoin/mainnet**  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available. 
 *
 * The version of the OpenAPI document: 2.0.0
 * Contact: support@blockdaemon.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


package com.gitlab.blockdaemon.ubiquity.model;

import java.util.Objects;
import java.util.Arrays;
import java.util.Map;
import java.util.HashMap;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonTypeName;
import com.fasterxml.jackson.annotation.JsonValue;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.gitlab.blockdaemon.ubiquity.invoker.JSON;


/**
 * AlgorandMeta
 */
@JsonPropertyOrder({
  AlgorandMeta.JSON_PROPERTY_TYPE,
  AlgorandMeta.JSON_PROPERTY_SENDER_REWARD,
  AlgorandMeta.JSON_PROPERTY_RECIPIENT_REWARD,
  AlgorandMeta.JSON_PROPERTY_CLOSE,
  AlgorandMeta.JSON_PROPERTY_CLOSE_AMOUNT,
  AlgorandMeta.JSON_PROPERTY_CLOSE_REWARD
})
@javax.annotation.Generated(value = "org.openapitools.codegen.languages.JavaClientCodegen")
public class AlgorandMeta {
  public static final String JSON_PROPERTY_TYPE = "type";
  private String type = "algorand_meta";

  public static final String JSON_PROPERTY_SENDER_REWARD = "sender_reward";
  private String senderReward;

  public static final String JSON_PROPERTY_RECIPIENT_REWARD = "recipient_reward";
  private String recipientReward;

  public static final String JSON_PROPERTY_CLOSE = "close";
  private String close;

  public static final String JSON_PROPERTY_CLOSE_AMOUNT = "close_amount";
  private String closeAmount;

  public static final String JSON_PROPERTY_CLOSE_REWARD = "close_reward";
  private String closeReward;


  public AlgorandMeta type(String type) {
    this.type = type;
    return this;
  }

   /**
   * Get type
   * @return type
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(value = "")
  @JsonProperty(JSON_PROPERTY_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getType() {
    return type;
  }


  @JsonProperty(JSON_PROPERTY_TYPE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setType(String type) {
    this.type = type;
  }


  public AlgorandMeta senderReward(String senderReward) {
    this.senderReward = senderReward;
    return this;
  }

   /**
   * Get senderReward
   * @return senderReward
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "121176", value = "")
  @JsonProperty(JSON_PROPERTY_SENDER_REWARD)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getSenderReward() {
    return senderReward;
  }


  @JsonProperty(JSON_PROPERTY_SENDER_REWARD)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setSenderReward(String senderReward) {
    this.senderReward = senderReward;
  }


  public AlgorandMeta recipientReward(String recipientReward) {
    this.recipientReward = recipientReward;
    return this;
  }

   /**
   * Get recipientReward
   * @return recipientReward
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0", value = "")
  @JsonProperty(JSON_PROPERTY_RECIPIENT_REWARD)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getRecipientReward() {
    return recipientReward;
  }


  @JsonProperty(JSON_PROPERTY_RECIPIENT_REWARD)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setRecipientReward(String recipientReward) {
    this.recipientReward = recipientReward;
  }


  public AlgorandMeta close(String close) {
    this.close = close;
    return this;
  }

   /**
   * Get close
   * @return close
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "XIU7HGGAJ3QOTATPDSIIHPFVKMICXKHMOR2FJKHTVLII4FAOA3CYZQDLG4", value = "")
  @JsonProperty(JSON_PROPERTY_CLOSE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getClose() {
    return close;
  }


  @JsonProperty(JSON_PROPERTY_CLOSE)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setClose(String close) {
    this.close = close;
  }


  public AlgorandMeta closeAmount(String closeAmount) {
    this.closeAmount = closeAmount;
    return this;
  }

   /**
   * Get closeAmount
   * @return closeAmount
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0", value = "")
  @JsonProperty(JSON_PROPERTY_CLOSE_AMOUNT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getCloseAmount() {
    return closeAmount;
  }


  @JsonProperty(JSON_PROPERTY_CLOSE_AMOUNT)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setCloseAmount(String closeAmount) {
    this.closeAmount = closeAmount;
  }


  public AlgorandMeta closeReward(String closeReward) {
    this.closeReward = closeReward;
    return this;
  }

   /**
   * Get closeReward
   * @return closeReward
  **/
  @javax.annotation.Nullable
  @ApiModelProperty(example = "0", value = "")
  @JsonProperty(JSON_PROPERTY_CLOSE_REWARD)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)

  public String getCloseReward() {
    return closeReward;
  }


  @JsonProperty(JSON_PROPERTY_CLOSE_REWARD)
  @JsonInclude(value = JsonInclude.Include.USE_DEFAULTS)
  public void setCloseReward(String closeReward) {
    this.closeReward = closeReward;
  }


  /**
   * Return true if this algorand_meta object is equal to o.
   */
  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    AlgorandMeta algorandMeta = (AlgorandMeta) o;
    return Objects.equals(this.type, algorandMeta.type) &&
        Objects.equals(this.senderReward, algorandMeta.senderReward) &&
        Objects.equals(this.recipientReward, algorandMeta.recipientReward) &&
        Objects.equals(this.close, algorandMeta.close) &&
        Objects.equals(this.closeAmount, algorandMeta.closeAmount) &&
        Objects.equals(this.closeReward, algorandMeta.closeReward);
  }

  @Override
  public int hashCode() {
    return Objects.hash(type, senderReward, recipientReward, close, closeAmount, closeReward);
  }

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("class AlgorandMeta {\n");
    sb.append("    type: ").append(toIndentedString(type)).append("\n");
    sb.append("    senderReward: ").append(toIndentedString(senderReward)).append("\n");
    sb.append("    recipientReward: ").append(toIndentedString(recipientReward)).append("\n");
    sb.append("    close: ").append(toIndentedString(close)).append("\n");
    sb.append("    closeAmount: ").append(toIndentedString(closeAmount)).append("\n");
    sb.append("    closeReward: ").append(toIndentedString(closeReward)).append("\n");
    sb.append("}");
    return sb.toString();
  }

  /**
   * Convert the given object to string with each line indented by 4 spaces
   * (except the first line).
   */
  private String toIndentedString(Object o) {
    if (o == null) {
      return "null";
    }
    return o.toString().replace("\n", "\n    ");
  }

}

